<?php

// (c) 2002 Michal Kebrt
// michalek.k@seznam.cz


// vytvori archivni stranku pro dany tyden
function Create_Archive($archive_date_from) {
	global $page, $today;
	
	// je datum predany v parametru mensi nez datum prvniho dne v aktualnim tydnu ?
	if($archive_date_from <= First_Day()) {
		$archive_date_to = $archive_date_from + 600000;	// datum posledniho dne v tydnu
		$from_to = Date("j. n. Y", $archive_date_from) . Date(" - j. n. Y", $archive_date_to); // od - do
		$article = '<h2 class="archive">' . $from_to . '</h2>';	// nadpis od - do
	
		// vybere clanky vydane v danem tydnu
		$query = MySQL_Query("SELECT article.id AS article_id, title, message, author, publish_date, archive_date, name, email FROM article, author WHERE author = author.id AND publish_date >= $archive_date_from AND publish_date <= $archive_date_to AND publish_date <= $today ORDER BY publish_date DESC")  or Weblog_Error(2);

		if(MySQL_Num_Rows($query)!=0) {
			while($result = MySQL_Fetch_Array($query)) $article .= Article($result); // pomoci funkce Article() se zpracuji vybrane clanky
		
			// vsechny znacky ze souboru page.php se nahradi prislusnymi informacemi
			$output = Str_Replace('$WEBLOG_TITLE$', 'Archiv - ' . $from_to, $page);
			$output = Str_Replace('$WEBLOG_ARTICLES$', $article, $output);
			$output = Str_Replace('$WEBLOG_ARCHIVE$', Archive_Links(), $output);
			
			// vytvori archivni stranku
			$fp = @FOpen('../' . Date("Y_m_d", $archive_date_from) . Date("_Y_m_d", $archive_date_to) . '.html', 'w') or Weblog_Error(3);
			FWrite($fp, $output);
			FClose($fp);
		}
	}
}

// vytvori kompletni archiv
function Create_Complete_Archive() {
	global $page, $today;
	
	$first_day_of_week = First_Day();	// datum prvniho dne v aktualnim tydnu
	$query = @MySQL_Query("SELECT DISTINCT archive_date FROM article WHERE archive_date <= $first_day_of_week ORDER BY archive_date") or Weblog_Error(2);	// vybere unikatni data a seradi vzestupne
	while($result = MySQL_Fetch_Array($query)) {
		$archive_date_from = $result['archive_date'];	// datum prvniho dne v tydnu
		$archive_date_to = $result['archive_date']+600000; // datum posledniho dne v tydnu
		$from_to = Date("j. n. Y", $archive_date_from) . Date(" - j. n. Y", $archive_date_to);	// od - do
		
		$article = '<h2 class="archive">' . $from_to . '</h2>'; // nadpis od - do

		// vybere clanky vydane v danem tydnu
		$query2 = MySQL_Query("SELECT article.id AS article_id, title, message, author, publish_date, archive_date, name, email FROM article, author WHERE author = author.id AND publish_date >= $archive_date_from AND publish_date <= $archive_date_to AND publish_date <= $today ORDER BY publish_date DESC")  or Weblog_Error(2);
		while($result2 = MySQL_Fetch_Array($query2)) $article .= Article($result2);	// pomoci funkce Article() se zpracuji vybrane clanky

		// vsechny znacky ze souboru page.php se nahradi prislusnymi informacemi
		$output = Str_Replace('$WEBLOG_TITLE$', 'Archiv - ' . $from_to, $page);
		$output = Str_Replace('$WEBLOG_ARTICLES$', $article, $output);
		$output = Str_Replace('$WEBLOG_ARCHIVE$', Archive_Links(), $output);
		
		// vytvori archivni stranku
		$fp = @FOpen('../' . Date("Y_m_d", $archive_date_from) . Date("_Y_m_d", $archive_date_to) . '.html', 'w') or Weblog_Error(3);
		FWrite($fp, $output);
		FClose($fp);
	}
}

$today = Time();
require "../page.php";

?>
