<?php

// (c) 2002 Michal Kebrt
// michalek.k@seznam.cz

// zabrani cashovani
Header("Pragma: No-cache");
Header("Cache-Control: No-cache, Must-revalidate");
Header("Expires: ".GMDate("D, d M Y H:i:s")." GMT");

ini_set('session.use_trans_sid', 1);	// zajisti prenos session id

require "checklogin.php"; // je autor prihlasen ?
require "../db.php"; // pripoji k databazi
require "../function.php"; // nacte soubor s dulezitymi funkcemi
require "msg.php"; // chybove hlasky a zpravy

$limit = 10; // pocet clanku na strance
$page_number = IsSet($_GET['page_number']) ? $_GET['page_number'] : 1; // stranka, ktera se zobrazi

// vytvori odkazy na jednotlive stranky s clanky
function Page_Links()
 {
 	global $user_type, $user_id, $limit, $page_number;

	// Admin muze pracovat se vsemi clanky, aUtor pouze s vlastnimi
	if($user_type=="A")	$sql = '';	
	if($user_type=="U") $sql = "WHERE author = $user_id";

	$query = @MySQL_Query("SELECT count(id) FROM article $sql") or Weblog_Error(2);
	$result = MySQL_Fetch_Array($query);
	$pages = Ceil($result['count(id)']/$limit);	// pocet stranek

	$link = '<div class="articlemenu">Zobrazit stranu: ';

	// vypocet pocatecni a koncove stranky (snazime se vypsat vzdy 10 odkazu)
	$start_page = $page_number-5;
	$end_page = $page_number+5;
	
	// pri prvnim vypoctu mohly byt do promennych vlozeny nekorektni (zaporne nebo prilis velke) hodnoty proto musime provest dodatecnou kontrolu
	if($start_page < 1) $end_page += Abs($start_page) + 1;
	if($end_page > $pages) {
		$start_page = $start_page - ($end_page-$pages);
		$end_page = $pages;
	}
	if($start_page < 1) $start_page = 1;
	
	// odkazy
	if($start_page > 1) $link .= '<a href="index.php?page_number=1">' . 1 . '</a> ... '; // odkaz na prvni stranku
	for($x = $start_page;$x <= $end_page;$x++)	$link .= '<a href="index.php?page_number=' . $x . '">' . $x . '</a>&nbsp;&nbsp;'; // odkazy na sranky v intervalu $start_page - $end_page
	if($end_page < $pages) $link .= '... <a href="index.php?page_number=' . $pages . '">' . $pages . '</a>'; // odkaz na posledni stranku
	if($page_number > 1) $link .= '&nbsp;&nbsp;<a href="index.php?page_number=' . ($page_number-1) . '">&lt;&lt;</a>';	// odkaz vpred
	if($page_number < $pages) $link .= '&nbsp;&nbsp;<a href="index.php?page_number=' . ($page_number+1) . '">&gt;&gt;</a>';	// odkaz vzad
	
	$link .= '</div>';
	return $link;
}

// vybere clanky
function Select_Articles()
 {
 	global $page_number, $limit, $user_id, $user_type;

	// na zaklade typu autora sestavi podminku (A = admin - ma prava ke vsem clankum, U = autor - ma prava pouze k vlastnim clankum)
	if($user_type=="A") $sql = '';	
	if($user_type=="U") $sql = "AND author = $user_id";

	$start = ($page_number-1)*$limit;	// prvni clanek, ktery se zobrazi
	$query = @MySQL_Query("SELECT article.id AS article_id, title, message, author, publish_date, name, email FROM article, author WHERE author = author.id $sql ORDER BY publish_date DESC LIMIT $start,$limit") or Weblog_Error(2);
	
	if(MySQL_Num_Rows($query)!=0) {
		$article = '';
		while($result = MySQL_Fetch_Array($query)) {
			$article .= Article($result, false);
			
			// ke kazdemu clanku prida odkazy "Smazat" a "Upravit"
			$article .= '<div class="articlemenu">';
			$article .= '<a href="update.php?article_id=' . $result['article_id'] . '">Upravit</a>';
			$article .= '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="index.php?action=delete&article_id=' . $result['article_id'] . '">Smazat</a>';
			$article .= "</div>\n";
		}
		$article .= Page_Links();	// na zaver se vlozi odkazy na dalsi stranky
		
	} else {
		$article = '<p class="message">Jet jste nenapsal dn lnek.</p>';
	}
	return $article;
 }

// byla odeslana promenna "action" ?
if(IsSet($_REQUEST['action'])) {
	switch($_REQUEST['action']) {

		// vlozi clanek
		case "post":
			// byly vyplneny oba povinne udaje ?
			if($_POST['title']=="" || $_POST['article_text'] =="") {
				$error = 4;
			// neni datum vydani mensi nez aktualni datum (rezerva 15 min) ?
			} elseif(MkTime($_POST['from_hour'], $_POST['from_minute']+15, 0, $_POST['from_month'], $_POST['from_day'], $_POST['from_year']) < Time()) {
				$error = 5;
			} else {
				// uprava vstupu
				$title = Text_Modify($_POST['title']);
				$article_text = Text_Modify($_POST['article_text']);
				$publish_date = MkTime($_POST['from_hour'], $_POST['from_minute'], 0, $_POST['from_month'], $_POST['from_day'], $_POST['from_year']); // datum vydani

				$day_number = Date("w", $publish_date);
				if($day_number == 0) $day_number = 7;
				$first_day_of_week = MkTime(0,0,0, $_POST['from_month'], $_POST['from_day']-$day_number+1, $_POST['from_year']); // datum prvniho dne v tydnu, ve kterem clanek vychazi

				$query = @MySQL_Query("INSERT INTO article VALUES ('', '$title', '$article_text', '$publish_date', '$user_id', '$first_day_of_week')") or Weblog_Error(2);
				$message = 1;
				
				// vygeneruje staticke stranky
				require "archive.php";
				Create_Archive($first_day_of_week);
				Create_Index("static");
				
				MySQL_Close();
				Header('Location: http://'. $_SERVER['HTTP_HOST'] . '/weblog/admin/index.php?message=' . URLDecode($message) .'&' . SID);	// navrat na uvodni stranku
				exit;

			}
			break;
		
		// smaze clanek
		case "delete":
			$article_id = $_GET['article_id'];
			$query = @MySQL_Query("SELECT author FROM article WHERE id = $article_id") or Weblog_Error(2);	// autor clanku
			$result = MySQL_Fetch_Array($query);

			// ma prihlaseny autor prava k tomuto clanku ?
			if($result["author"] == $user_id || $user_type == "A") {
				$query = @MySQL_Query("SELECT archive_date FROM article WHERE id = $article_id") or Weblog_Error(2);	// tyden, ve kterem clanek vysel
				$result = MySQL_Fetch_Array($query);
				
				$query = @MySQL_Query("DELETE FROM article WHERE id = $article_id") or Weblog_Error(2);
				$message = 2;
		
				// vygeneruje staticke stranky
				require "archive.php";
				Create_Archive($result['archive_date']);
				Create_Index("static");
			} else {
				$message = 4;
			}

			MySQL_Close();
			Header('Location: http://'. $_SERVER['HTTP_HOST'] . '/weblog/admin/index.php?message=' . $message .'&' . SID);	// navrat na uvodni stranku
			exit;
			break;
	}
}
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<title>Administrace</title>
<style media="all" type="text/css">@import "style.css";</style>
<meta http-equiv="Content-Type" content="text/html; charset=windows-1250">
<meta http-equiv="Cache-control" content="no-cache">
<meta http-equiv="Pragma" content="no-cache">
<meta http-equiv="Expires" content="0">
</head>
<body>

<h2 class="heading">Weblog - administrace</h2>

<?php
// prihlaseny autor
echo '<p class="authorinfo">' . $name . ' /' . $email . '/&nbsp;&nbsp;&nbsp;';
echo '<a href="login.php?logout=yes">odhlsit</a></p>';

// chybove hlasky a zpravy
if(IsSet($_GET['error'])) $error = $_GET['error'];
if(IsSet($_GET['message'])) $message = $_GET['message'];
if(IsSet($error) && IsSet($msg_error[$error])) echo	'<p class="error">' . $msg_error[$error] . '</p>';
if(IsSet($message) && IsSet($msg_message[$message])) echo '<p class="message">' . $msg_message[$message] . '</p>';
?>

<h3 class="heading">Vloit lnek</h3>

<?php
// vlozi formular pro pridani clanku
require "form.php";
?>

<h3 class="heading">Administrace lnk</h3>

<?php
// zobrazi clanky
echo Select_Articles();
MySQL_Close();
?>

</body>
</html>