<?php

// (c) 2002 Michal Kebrt
// michalek.k@seznam.cz

// zpracuje jednotlive clanky, v prvnim parametru je predan vysledek SQL dotazu
// druhy parametr urcuje, zda bude vlozen "trvaly odkaz"
function Article($result, $permalink = true) {
	$publish_date = Date("j. n. Y H:i", $result['publish_date']);	// prevede datum na srozumitelny format
	
	// kazdy clanek je zvlastnim bloku
	$article = '<div class="article">';
	$article .= '<a name="' . $result['article_id'] . '"></a>';	// zalozka
	$article .= '<h2>' . $result["title"] . '</h2>';	// titulek
	$article .= '<p>' . $result["message"] . '</p>';	// text clanku
	$article .= '<p class="author"><a href="mailto:' . $result["email"] . '">' . $result["name"] . '</a> /' . $publish_date . '/'; // autor + datum vydani

	// ma byt pridan trvaly odkaz ?
	if($permalink) $article .= '&nbsp;&nbsp;&nbsp; <a href="' . Date("Y_m_d", $result['archive_date']) . Date("_Y_m_d", $result['archive_date'] + 600000) . '.html#' . $result['article_id'] . '" class="permalink">trval odkaz</a></p>';

	$article .= "</div>\n";
	return $article;
 }


// vraci datum prvniho den v tydnu jako pocet sekund od 1.1. 1970
function First_Day() {
	$day_number = Date("w");	// cislo dne v tydnu 
	if($day_number == 0) $day_number = 7;	// nedeli nepovazujeme za prvni, ale posledni den tydne
	return MkTime(0,0,0, Date("m"), Date("d")-$day_number+1, Date("y"));
 }


// vytvari odkazy na archivni stranky
function Archive_Links() {
	$first_day_of_week = First_Day();	// datum prvniho dne v tydnu

	// vybere data a seradi vzestupne
	$query = @MySQL_Query("SELECT DISTINCT archive_date FROM article WHERE archive_date <= $first_day_of_week ORDER BY archive_date DESC") or Weblog_Error(2);
	$link = '';
	while($result = MySQL_Fetch_Array($query)) {
	 	$archive_date_from = $result['archive_date'];	// prvni den tydne
		$archive_date_to = $result['archive_date'] + 600000;	// posledni den tydne
		$from_to = Date("j. n. Y", $archive_date_from) . Date(" - j. n. Y", $archive_date_to); // prevede datum na srozumitelnejsi podobu
		
		// vytvori odkazy
		$link .= '<li>';
		$link .= '<a href="' . Date("Y_m_d", $archive_date_from) . Date("_Y_m_d", $archive_date_to) . '.html">' . $from_to . '</a>';
		$link .= '</li>';
	 }
	return $link;
 }

// vytvori uvodni stranku
function Create_Index($type) {
	global $page;
	$today = Time(); // aktualni cas
	
	// vybere 20 nejnovejsich clanku
	$query = MySQL_Query("SELECT article.id AS article_id, title, message, author, publish_date, archive_date, name, email FROM article, author WHERE author = author.id AND publish_date <= $today ORDER BY publish_date DESC LIMIT 0,20")  or Weblog_Error(2);

	if(MySQL_Num_Rows($query)!=0) {
		$count_article = MySQL_Num_Rows($query);	// pocet vybranych clanku
		
		// vybrane clanky jsou z obdobi OD - DO
		$date_from = MySQL_Result($query, 0, "publish_date");	// od
		$date_to = MySQL_Result($query, $count_article-1, "publish_date");	// do
		$from_to = Date("j. n. Y", $date_from) . Date(" - j. n. Y", $date_to);	// od - do
		$article = '<h2 class="archive">' . $from_to . '</h2>'; // nadpis od - do
	
		$move = MySQL_Data_Seek($query, 0);	// presuneme se znovu na zacatek
		while($result = MySQL_Fetch_Array($query)) $article .= Article($result); // pomoci funkce Article() se zpracuji vybrane clanky

		// vsechny znacky ze souboru page.php se nahradi prislusnymi informacemi
		$output = Str_Replace('$WEBLOG_TITLE$', 'Weblog', $page);
		$output = Str_Replace('$WEBLOG_ARTICLES$', $article, $output);
		$output = Str_Replace('$WEBLOG_ARCHIVE$', Archive_Links(), $output);
		
		// na zaklade parametru $type se bud vygeneruje staticka stranka index.html,
		// nebo je cela stranka pouzita pro dynamicky generovanou stranku
		if($type=="static") {
			$fp = @FOpen('../index.html', 'w') or Weblog_Error(3);
			FWrite($fp, $output);
			FClose($fp);
		} elseif($type=="dynamic") {
			return $output;
		}
	}
}

function Text_Modify($text) {
	$text = Trim($text);	// odstrani mezery z obou koncu retezce
	$text = HTMLSpecialChars($text, ENT_QUOTES);	// prevede nebezpecne znaky

	// nahradi konce radku na tagy <br />
	$text = Str_Replace("\r\n"," <br /> ", $text);
	$text = Str_Replace("\n"," <br /> ", $text);
	
	// umozni vkladat nektere parove tagy
	$tags = Array("b", "u", "i", "small", "big", "strong", "em");
	while(Current($tags)) {
		$tag = Current($tags);
		$text = Preg_Replace('\'&lt;' . $tag . '&gt;(.*?)&lt;/' . $tag . '&gt;\''. "si", ' <' . $tag . '>\\1</' . $tag . '> ', $text);
		Next($tags);
	}
	
	// umozni vkladat nektere neparove tagy
	$tags2 = Array("br", "hr");
	while(Current($tags2)) {
		$text = EregI_replace("&lt;" . Current($tags2) . "( /)?&gt;", "<" . Current($tags2) . " />", $text);
		Next($tags2);
	}
	
	/*
	// vytvori odkazy
	$text = EregI_Replace("(http://[^ ]+\.[^< ]+)", "<a href=\"\\1\">\\1</a>", $text);
	$text = EregI_Replace("[^/](www\.[^ ]+\.[^< ]+)", "<a href=\"http://\\1\">\\1</a>", $text);
	*/

	$words = Split("[[:blank:]]+", Trim($text));		//rozdeleni textu na slova
	$connect_text = '';

	while(Current($words)) {
		$word = Trim(Current($words));			//odstraneni mezer na konci slova
		if(EregI("http://[^ ]+\.[^< ]+", $word, $part)) {
			$word = Str_Replace($part[0], '<a href="' . $part[0] . '">' . Wordwrap($part[0], 25, " ", 1) . '</a>', $word);
		} elseif(EregI('www\.[^ ]+\.[^< ]+', $word, $part)) {
			$word = Str_Replace($part[0], '<a href="http://' . $part[0] . '">' . Wordwrap($part[0], 25, " ", 1) . '</a>', $word);
		} else {
			$word = Wordwrap($word, 40, " ", 1);
		}
		$connect_text .= $word . " ";
		Next($words);
	}
	return Trim($connect_text);
}

function un_Text_Modify($text) {
	/*
	$trans_tbl = Get_HTML_Translation_Table(HTML_SPECIALCHARS);
	$trans_tbl = Array_Flip($trans_tbl);
	$text = StrTr($text, $trans_tbl);
	*/

	$text = EregI_Replace(" <br /> ","\n", $text);
	$text = EregI_Replace('<a href="([^"]+)">[^<]+</a>', "\\1", $text);

	return $text;
}
?>